/**
 * Informatique Industrielle et Java
 * exercice 5.3 du chapitre 5
 * 
 * Projet: ecriture sur un port de communication
 *
 * Cr l'environnement graphique pour illustrer l'ecriture sur un port
 * les ports disponibles sont affichs dans une JList
 * Deux boutons permettent de fermer et d'ouvrir les ports
 * Une zone de saisie de texte permet de saisir le texte qui est envoye
 * sur le port srie.
 *
 * @author F.Mallet
 * @version 2003.04
 */

import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JList;
import javax.swing.JButton;

public class Environnement {
	private JFrame fenetre;
	
	public Environnement(String name) {
		fenetre = new JFrame(name);
		
		// L'organisateur cherche les ports disponibles sur le systme est les prsente
		// sous la forme d'un modle pour une JList
		PortOrganisateur organisateur = new PortOrganisateur(name);
		
		// Cette JList prsente les ports disponibles sur le systme
		JList ports = new JList(organisateur);
		fenetre.getContentPane().add(ports);
		
		// Permet d'ouvrir le port slectionn dans la liste
		JButton ouvrirB = new JButton("Ouvrir");
		fenetre.getContentPane().add(ouvrirB, "North");	
		
		// Permer de fermer le port slectionn dans la liste
		JButton fermerB = new JButton("Fermer");
		fenetre.getContentPane().add(fermerB, "South");
		
		// Permet de saisir le texte  envoyer
		JTextField zoneEcriture = new JTextField(10);
		fenetre.getContentPane().add(zoneEcriture, "West");
		
		// Permet d'afficher le texte reu
		JTextArea texteRecu = new JTextArea(5,10);
		fenetre.getContentPane().add(texteRecu, "East");
		
		// Cette ecouteur ecoute les vnements qui proviennes des deux boutons
		Ecouteur ecouteur = new Ecouteur(organisateur, ports);
		ouvrirB.addActionListener(ecouteur);		
		fermerB.addActionListener(ecouteur);		
		
		// La zone d'criture met un vnement lorsque le texte est valid
		Ecrivain ecrivain = new Ecrivain(organisateur, ports);
		zoneEcriture.addActionListener(ecrivain);
		
		// La sortie standard est redirige vers la zone de texte
		MonFlot monflot = new MonFlot(texteRecu);
		System.setOut(monflot);
		System.out.println("Le nouveau flot est actif");
		System.out.print(6);
		System.out.println(-25);
		
		fenetre.pack();
		// Lorsque la fentre est ferme, l'application se termine
		fenetre.setDefaultCloseOperation(fenetre.EXIT_ON_CLOSE);
	}
	
	public void affiche() {
		fenetre.setVisible(true);
	}
	
	// Cette application a un paramtre qui reprsente le nom de l'application
	// Ce nom est utilis lors de la gestion des conflits pour afficher un 
	// message explicite.
	static public void main(String []args) {
		if (args.length == 0) {
			System.err.println("Vous devez donner un nom a votre application");
		} else {
			Environnement env = new Environnement(args[0]);
			env.affiche();
		}
	}
}
